//<html><pre>
/* ----------------------------------------------------------------------------------------------
    dot_font.java	hbgtHg							ver. 2.00  (JDK 1.02)
    														ueyama@infonet.co.jp  2002.10.20
    														update: 2007.09.12
---------------------------------------------------------------------------------------------- */

import java.applet.Applet;
import java.awt.*;


public class dot_font extends Applet
{
	boolean		Dd[][]= new boolean[24][24];							// tHgf[^  true: 
	int			P[]={19,13};											// hbgsb`
	int			N[]={16,24};											// hbg
	int			R[]={10,6};												// hbga
	int			Fx[]={34,30}, Fy[]={346,342};							// tHg\W
	int			Dx[]={83,75}, Dy[]={338,330};							// tHg{\W
	int			Bx=160, By=345;											// {^\W
	int			Cx=368, Cy=2;											// R[h (16i) \W
	int			M=0;													// 0: 16~16  1: 24~24
	int			Dm=0;													// 0: t[nh  1: o[oh
	int			Q=0;													// hbg̐
	int			Mx, My, Xm, Ym;
	int			Xd, Yd;
	Graphics	gr;
	Image		Img;
	int			Bgc;
	int			i=0, j=0;
	
	public void init()
	{
		String	bg=getParameter("bgcolor");
		int		Bgc=Integer.valueOf(bg,16).intValue();
		setBackground(new Color(Bgc));
		MediaTracker mt=new MediaTracker(this);
		Img=getImage(getCodeBase(), getParameter("figure"));
		mt.addImage(Img, 0);
		try
		{
			mt.waitForID(0);
		}
		catch(InterruptedException e){};
		gr=getGraphics();
	}
	
	public boolean inside(int n, int a, int b)
	{
		return (n<=Math.max(a,b) && n>=Math.min(a,b)) ? true:false;
	}

	public void dsp_dot()												// tHggʁiҏWpj̕\
	{
		gr.clearRect(0, 0, 313, 313);									// \̈̃NA
		gr.setColor(new Color(Bgc));
		for(i=0; i<=N[M]; i+=4) gr.drawLine(i*P[M], 0, i*P[M],  P[M]*N[M]);	// r`
		for(i=0; i<=N[M]; i+=4) gr.drawLine(0, i*P[M], P[M]*N[M], i*P[M]);
		for(i=0; i<N[M]; i++) for(j=0; j<N[M]; j++) dsp_g(i*P[M], j*P[M], (Dd[i][j])?1:0, 0, M);	// f[^̕\
	}
	
	public void dsp_font()												// tHǧE{\
	{
		gr.clearRect(Fx[1], Fy[1], 26, 26);								// \̈̃NA
		gr.clearRect(Dx[1], Dy[1], 50, 50);
		gr.setColor(Color.white);
		gr.fillRect(Fx[M], Fy[M], N[M]+1, N[M]+1);						// \GA𔒂œhԂ
		gr.fillRect(Dx[M], Dy[M], N[M]*2+1, N[M]*2+1);
		gr.setColor(new Color(153,153,153));
		gr.drawRect(Fx[M], Fy[M], N[M]+1, N[M]+1);						// g̕`
		gr.drawRect(Dx[M], Dy[M], N[M]*2+1, N[M]*2+1);
		for(i=0; i<N[M]; i++) for(j=0; j<N[M]; j++)						// tHgf[^̕\
		{
			if(Dd[i][j])
			{
				dsp_g(Fx[M]+i+1, Fy[M]+j+1, 0, 0, 5);					// tHg\
				dsp_g(Dx[M]+i*2+1, Dy[M]+j*2+1, 0, 0, 6);				// tHg{\
			}
		}
	}
	
	public void dsp_code()												// R[hi16if[^j̕\
	{
		int k,m,n=0,x,y=(M==0)?3:0;
		for(i=0; i<N[M]; i++)
		{
			x=Cx;
			for(j=0; j<N[M]/4; j++)										// s 2 or 3 oCgŕ\
			{
				m=8; n=0;
				for(k=0; k<4; k++)										// 4 bit  10iϊ
				{
					if(Dd[j*4+k][i]) n+=m;
					m/=2;
				}
				dsp_g(x, Cy+i*P[M]+y, n, 0, 2);							// 16i\
				x+=10; 
				x+=(j%2)*5;												// oCgԂ̃Xy[X
			}
		}
	}

	public void dsp_g(int x, int y, int m, int n, int c)				// 摜̕\
	{
		int w=0,h=0, ox=0,oy=0;
		switch(c)
		{
			case  0: w= 20; h= 20; ox=  0; oy=  0; break;				//  ()
			case  1: w= 14; h= 14; ox=  0; oy= 20; break;				//  ()
			case  2: w= 11; h= 11; ox=248; oy=  0; break;				// 16i
			case  3: w= 65; h= 23; ox= 40; oy=  0; break;				// 16~16, 24~24 {^
			case  4: w= 26; h= 23; ox=170; oy=  0; break;				// {^
			case  5: w=  1; h=  1; ox= 29; oy=  9; break;				// E (tHg\pj
			case  6: w=  2; h=  2; ox= 29; oy=  9; break;				//  (tHg{\pj
		}
		Graphics gx=gr.create();
		gx.clipRect(x,y,w,h);
		if(c==2) gx.clearRect(x,y,w,h);
		gx.drawImage(Img, x-(ox+w*m), y-(oy+h*n), this);
		gx.dispose();
	}
	
	public void paint(Graphics g)
	{
		g.clearRect(0,0,size().width,size().height);					// ʂ̃NA
		dsp_dot();														// tHggʁiҏWpj̕\
		dsp_font();														// tHǧE{\
		dsp_code();														// R[hi16if[^j̕\
		dsp_g(Bx, By, 0, (M==0)?1:0, 3);								// 16~16 ^ 24~24 {^̕\
		dsp_g(Bx+71, By, (Dm==0)?2:0, 1, 4);							// OՁ^o[oh {^̕\
		dsp_g(Bx+100, By, (Q==0)?2:0, 0, 4);							// NA {^̕\
	}
	
	public void put_dot(int i, int j)
	{
		Dd[i][j] = !Dd[i][j];											// f[^𔽓]
		dsp_g(i*P[M], j*P[M], (Dd[i][j])?1:0, 0, M);					// hbg̕\
		for(Q=0,i=0;i<N[M];i++) for(j=0;j<N[M];j++) if(Dd[i][j]) Q++;	// hbgJEg
		dsp_g(Bx+100, By, (Q==0)?2:0, 0, 4);							// NA{^̕\XV
		dsp_font();														// tHǧE{\
	}

	public boolean mouseDown(Event e, int mx, int my)
	{
		Mx=mx; My=my; Xm=mx; Ym=my;
		if(mx<P[M]*N[M] && my<P[M]*N[M])								// hbg̕ҏW
		{
			put_dot(mx/P[M], my/P[M]);
			Xd=mx/P[M]; Yd=my/P[M];
		}
		else if(inside(my,By,By+23))									// {^NbN
		{
			if(inside(mx, Bx, Bx+65) || (inside(mx, Bx+100, Bx+126) && Q>0))
			{
				if(inside(mx, Bx, Bx+65))								// 16~16 ^ 24~24 {^NbN
				{
					M=(M==0)? 1:0;										// [h̕ύX
					dsp_g(Bx, By, 1, M, 3);								// 16~16 ^ 24~24 {^̗ΐF\
				}
				if(inside(mx, Bx+100, Bx+126))							// NA{^NbN
				{
					dsp_g(Bx+100, By, 1, 0, 4);							// NA {^̗ΐF\
					for(i=0; i<N[M]; i++) for(j=0; j<N[M]; j++) Dd[i][j]=false;	// f[^̃NA
					Q=0;
				}
				dsp_dot();												// tHggʁiҏWpj̕\
				dsp_font();												// tHǧE{\
				gr.clearRect(Cx,Cy,70,312);								// R[h\̈̃NA
				dsp_code();												// R[hi16if[^j̕\
			}
			if(inside(mx, Bx+71, Bx+97))								// OՁ^o[oh {^NbN
			{
				dsp_g(Bx+71,By,(Dm==0)?3:1,1,4);						// OՁ^o[oh {^̗ΐF\
				Dm=(Dm==0)? 1:0;										// hbO[h̕ύX
			}
			Mx=-1;
		}
		return true;
	}
	
	public boolean mouseUp(Event e, int mx, int my)						// NbNihbOjIƂ̏
	{
		int x=Math.min(Mx,Xm), y=Math.min(My,Ym), w=Math.abs(Xm-Mx), h=Math.abs(Ym-My), m=P[M];
		Rectangle r=new Rectangle(x,y,w,h), t=new Rectangle(0,0,0,0), s=new Rectangle(0,0,0,0);
		if(Mx>=0)														// hbg̕ҏW
		{
			gr.drawRect(x,y,w,h);										// o[oh̏
			gr.setPaintMode();
			for(i=0; i<N[M]; i++)
			{
				for(j=0; j<N[M]; j++)
				{
					s=new Rectangle(i*m,j*m,m,m);						// s ̓hbg܂ސ`
					t=s.intersection(r);								// t ̓o[oh (r) ƏdȂ`
					if(t.width>0 && t.height>0)							// t o[ohł
					{
						dsp_g(i*m, j*m, (Dd[Mx/m][My/m])?1:0, 0, M);	// hbg̕\
						Dd[i][j]=Dd[Mx/m][My/m];						// f[^̍XV
					}
				}
			}
			dsp_font();													// tHǧE{\
			dsp_code();													// R[hi16if[^j̕\
		}
		if(my>By)														// {^NbN
		{
			if(inside(mx, Bx, Bx+65)) dsp_g(Bx,By,0,(M==0)?1:0,3);			// 16~16 ^ 24~24 {^̕\XV
			if(inside(mx, Bx+71, Bx+97)) dsp_g(Bx+71,By,(Dm==0)?2:0,1,4);	// OՁ^o[oh {^̕\XV
			if(inside(mx, Bx+100, Bx+126)) dsp_g(Bx+100,By,(Q==0)?2:0,0,4);	// NA{^̕\XV
		}
		return true;
	}

	public boolean mouseDrag(Event e, int mx, int my)					// }EXhbOꂽƂ̏
	{
		int x, y, w, h;
		if(mx<P[M]*N[M] && my<P[M]*N[M] && (Xd!=mx/P[M] || Yd!=my/P[M]) && Dm==0)	// OՃ[h
		{
			x=mx%P[M]-R[M]; y=my%P[M]-R[M];
			if(x*x+y*y<=R[M]*R[M])										// }EXhbg̉~ɂ
			{
				put_dot(mx/P[M], my/P[M]);								// hbg`
				Xd=mx/P[M]; Yd=my/P[M];
			}
		}
		if(mx<P[M]*N[M] && my<P[M]*N[M] && Mx>=0 && Dm==1)				// o[oh[h
		{
			gr.setXORMode(new Color(200,66,66));
			x=Math.min(Mx,Xm); y=Math.min(My,Ym); w=Math.abs(Xm-Mx); h=Math.abs(Ym-My);
			gr.drawRect(x,y,w,h);										// Â`
			x=Math.min(Mx,mx); y=Math.min(My,my); w=Math.abs(mx-Mx); h=Math.abs(my-My);
			gr.drawRect(x,y,w,h);										// V``
			Xm=mx;Ym=my;
		}
		return true;
	}
}
//</pre><a HREF="JavaScript:history.go(-1)">߂</A></html>
